digiKam Developer Documentation: Digikam::DPlugin Class Reference

| digiKam Developer Documentation Professional Photo Management with the Power of Open Source

Loading...
Searching...
No Matches
Public Member Functions | List of all members
Digikam::DPlugin Class Referenceabstract

A digiKam external plugin abstract class.

Inheritance diagram for Digikam::DPlugin:

## Public Member Functions
| DPlugin (QObject *const parent=nullptr)
| Constructor with optional parent object.
| ~DPlugin () override
| Destructor.
virtual QList< DPluginAuthor > | authors () const =0
| Returns authors list for the plugin.
virtual QStringList | categories () const =0
| Return a list of categories as strings registered in this plugin.
virtual void | cleanUp ()
| Plugin method to clean up internal created objects.
virtual int | count () const =0
| Return the amount of tools registered to all parents.
virtual QString | description () const =0
| Returns a short description about the plugin.
virtual QString | details () const =0
| Returns a long description about the plugin.
virtual QMap< QString, QStringList > | extraAboutData () const
| Returns a map of extra data to show in plugin about dialog.
virtual QStringList | extraAboutDataRowTitles () const
| Returns a list of extra data row titles to show in tab of plugin about dialog.
virtual QString | extraAboutDataTitle () const
| Returns the tab title of data returned by extraAboutData().
virtual QString | handbookChapter () const
| Return the online handbook chapter from an handbook section corresponding to this plugin.
virtual QString | handbookReference () const
| Return the online handbook reference from an handbook chapter corresponding to this plugin.
virtual QString | handbookSection () const
| Return the online handbook section corresponding to this plugin.
virtual bool | hasVisibilityProperty () const
| Return true if plugin can be configured in setup dialog about the visibility property.
virtual QIcon | icon () const
| Returns an icon for the plugin.
virtual QString | ifaceIid () const =0
| Returns the unique top level internal identification property of the plugin interface.
virtual QString | iid () const =0
| Returns the unique internal identification property of the plugin.
QString | libraryFileName () const
| Returns the file name of the library for this plugin.
virtual QString | name () const =0
| Returns the user-visible name of the plugin.
QStringList | pluginAuthors () const
| Return a list of authors as strings registered in this plugin.
void | setLibraryFileName (const QString &)
| Sets the file name of the library for this plugin.
void | setShouldLoaded (bool b)
| Accessor to adjust the should loaded plugin property.
virtual void | setup (QObject *const parent)=0
| Plugin factory method to create all internal object instances for a given parent.
virtual void | setVisible (bool b)=0
| Holds whether the plugin can be seen in parent view.
bool | shouldLoaded () const
| Return the should loaded property.
QString | version () const
| Return the internal version used to check the binary compatibility at run-time.

## Member Function Documentation

## ◆ categories()

virtual QStringList Digikam::DPlugin::categories | ( |  | ) | const
| pure virtual

Implemented in Digikam::DPluginDImg, Digikam::DPluginEditor, Digikam::DPluginGeneric, Digikam::DPluginRawImport, and Digikam::DPluginBqm.

## ◆ cleanUp()

virtual void Digikam::DPlugin::cleanUp | ( |  | ) |
| inlinevirtual

This method is called by plugin loader.

## ◆ count()

virtual int Digikam::DPlugin::count | ( |  | ) | const
| pure virtual

Implemented in Digikam::DPluginDImg, Digikam::DPluginEditor, Digikam::DPluginGeneric, Digikam::DPluginRawImport, and Digikam::DPluginBqm.

## ◆ extraAboutData()

virtual QMap< QString, QStringList > Digikam::DPlugin::extraAboutData | ( |  | ) | const
| inlinevirtual

Reimplemented in Digikam::DPluginDImg.

## ◆ extraAboutDataRowTitles()

virtual QStringList Digikam::DPlugin::extraAboutDataRowTitles | ( |  | ) | const
| inlinevirtual

Reimplemented in Digikam::DPluginDImg.

## ◆ extraAboutDataTitle()

virtual QString Digikam::DPlugin::extraAboutDataTitle | ( |  | ) | const
| inlinevirtual

Reimplemented in Digikam::DPluginDImg.

## ◆ handbookChapter()

QString Digikam::DPlugin::handbookChapter | ( |  | ) | const
| virtual

It's used in plugin dialog Help button. By default, no chapter is defined, and root page of the section is loaded by Help Button in this case. Note: a chapter is always included in a section. See handbookSection() for details.

## ◆ handbookReference()

QString Digikam::DPlugin::handbookReference | ( |  | ) | const
| virtual

It's used in plugin dialog Help button. By default, no reference is defined, and root page of the chapter is loaded by Help Button in this case. Note: a reference is always included in a chapter. See handbookChapter() for details.

## ◆ handbookSection()

QString Digikam::DPlugin::handbookSection | ( |  | ) | const
| virtual

It's used in plugin dialog Help button. By default, no section is defined, and root page of the documentation is loaded by Help Button in this case.

## ◆ hasVisibilityProperty()

bool Digikam::DPlugin::hasVisibilityProperty | ( |  | ) | const
| virtual

Default implementation return true.

Reimplemented in Digikam::DPluginDImg, and Digikam::DPluginBqm.

## ◆ icon()

QIcon Digikam::DPlugin::icon | ( |  | ) | const
| virtual

Default implementation return the system plugin icon.

## ◆ ifaceIid()

virtual QString Digikam::DPlugin::ifaceIid | ( |  | ) | const
| pure virtual

Must be formatted as "org.kde.digikam._NAME_OF_INTERFACE_/_VERSION_". Examples: "org.kde.digikam.DPluginGeneric/1.1.0" "org.kde.digikam.DPluginEditor/1.1.0" "org.kde.digikam.DPluginBqm/1.1.0"

Implemented in Digikam::DPluginDImg, Digikam::DPluginEditor, Digikam::DPluginGeneric, Digikam::DPluginRawImport, and Digikam::DPluginBqm.

## ◆ iid()

virtual QString Digikam::DPlugin::iid | ( |  | ) | const
| pure virtual

Must be formatted as "org.kde.digikam.plugin._PLUGIN_TYPE_._NAME_OF_PLUGIN_". Examples: "org.kde.digikam.plugin.generic.Calendar" "org.kde.digikam.plugin.editor.AdjustCurvesTool" "org.kde.digikam.plugin.bqm.NoiseReduction"

## ◆ libraryFileName()

QString Digikam::DPlugin::libraryFileName | ( |  | ) | const

This string is filled at run-time by plugin loader.

## ◆ name()

virtual QString Digikam::DPlugin::name | ( |  | ) | const
| pure virtual

The user-visible name should be context free, i.e. the name should provide enough information as to what the plugin is about in the context of digiKam.

## ◆ setLibraryFileName()

void Digikam::DPlugin::setLibraryFileName | ( | const QString & | name | ) |

This string is filled at run-time by plugin loader.

## ◆ setShouldLoaded()

void Digikam::DPlugin::setShouldLoaded | ( | bool | b | ) |

This property is adjusted by plugin loader at start-up.

## ◆ setVisible()

virtual void Digikam::DPlugin::setVisible | ( | bool | b | ) |
| pure virtual

Implemented in Digikam::DPluginEditor, Digikam::DPluginGeneric, Digikam::DPluginBqm, Digikam::DPluginDImg, and Digikam::DPluginRawImport.

## ◆ shouldLoaded()

bool Digikam::DPlugin::shouldLoaded | ( |  | ) | const

If it's true, the plugin must be loaded in application GUI at startup by plugin loader.

## ◆ version()

QString Digikam::DPlugin::version | ( |  | ) | const

This is typically the same version of digiKam core used at compilation time.